<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="d-flex flex-row-reverse flex-nowrap h-100 w-100">

  <app-folder-filter-panel
    (closeFiltersEvent)="toggleFilterPanel()"
    (updateFilterEvent)="filterChanged($event)"
    [active]="showFilterPanel"
    [filter]="appliedFilter"
    [originalFilter]="originalFilter">
  </app-folder-filter-panel>

  <div class="p-4 h-100 w-100 bg-light">

    <app-breadcrumbs></app-breadcrumbs>

    <div
      class="h4 mt-4 fw-bold"
      [innerText]="folderState | stateName">
    </div>

    <!-- Header -->

    <button
      ls-button
      size="sm"
      [text]="commonMessages.CREATE_FOLDER"
      [icon]="commonIcons.CREATE_ICON"
      *ngIf="isCreateFolderAvailable()"
      class=" btn btn-sm btn-primary"
      routerLink="/tenant/{{tenant.id}}/desk/{{deskId}}/draft/create"
      type="button">
      <fa-icon [icon]="commonIcons.ADD_ICON"></fa-icon>
      {{ commonMessages.CREATE_FOLDER }}
    </button>

    <div class="my-2 d-flex flex-row justify-content-end align-items-center">

      <app-multiple-action-list
        (actionPerformed)="onMultipleActionSuccess($event)"
        [actions]="actionsToDisplay"
        [deskId]="deskId"
        [folders]="selectedFolders"
        [tenant]="tenant"
        [userPreferences]="userPreferences"
        [asDelegate]="viewingDelegatedFolders()"
        class="flex-grow-1">
      </app-multiple-action-list>

      <span class="flex-grow-1"></span>

      <span
        [innerHTML]="commonMessages.PAGINATION_SIZE_LABEL"
        class="p-1 px-2">
      </span>

      <ngb-pagination
        [(page)]="pageSizeIndex"
        [boundaryLinks]="false"
        [collectionSize]="pageSizes.length"
        [directionLinks]="false"
        [pageSize]="1"
        [rotate]="false"
        (pageChange)="pageSizeChange($event)"
        class="me-2"
        size="sm">
        <ng-template let-p ngbPaginationNumber>{{ getPageSize(p) }}</ng-template>
      </ngb-pagination>

      <fa-icon
        *ngIf="show52Features"
        [icon]="cogIcon"
        [ngbTooltip]="commonMessages.TABLE_LAYOUT_COG_TOOLTIP"
        (click)="openTableLayoutModal()"
        class="float-end pointer me-2 mt-1 mb-1 text-primary">
      </fa-icon>

      <div class="d-flex align-items-center me-2">
        <ng-select
          [(ngModel)]="selectedFilterId"
          (change)="selectedFilterChange($event)"
          [multiple]="false"
          [notFoundText]="commonMessages.NO_VALUE"
          [placeholder]="commonMessages.FILTER_FIELD_PH"
          [searchable]="false"
          class="filter-selection"
          id="currentFilter">

          <ng-option
            *ngFor="let filter of userFolderFilters"
            [innerText]="filter.filterName"
            [value]="filter.id">
          </ng-option>
        </ng-select>
      </div>

      <button
        (click)="toggleFilterPanel()"
        [iconOnLeft]="false"
        [icon]="showFilterPanel ? icons.HIDE_PANEL_ICON : icons.SHOW_PANEL_ICON"
        [text]="commonMessages.FILTER_BUTTON_LABEL"
        ls-button>
      </button>
    </div>

    <!-- List -->

    <!-- The `aria-labelledby` does not have a label available, we go for the simple label -->
    <!-- eslint-disable-next-line -->
    <table
      [summary]="messages.TASKS_LIST"
      *ngIf="userPreferences"
      class="table-text-overflow w-100 bg-white mt-4 table table-fixed table-striped table-borderless border shadow-sm">
      <thead class="border">
        <tr class="w-100">
          <th class="th text-end col-checkbox-fixed-size">
            <div class="custom-control custom-checkbox">
              <input
                (ngModelChange)="handleCheckOrUncheckAll($event)"
                [(ngModel)]="allFoldersSelected"
                [id]="'checkbox_checkAll'"
                class="custom-control-input"
                type="checkbox">
              <label
                [htmlFor]="'checkbox_checkAll'"
                class="custom-control-label">
              </label>
            </div>
          </th>
          <ng-container *ngFor="let column of usedColumns">
            <th
              *ngIf="(shouldShowIdColumn() || !isIdColumn(column)) && (column.id !== 'ORIGIN_USER' || show52Features)"
              (click)="onRowOrderClicked(column.id)"
              [ngClass]="{
                'col-icon-fixed-size' : column.id === taskViewColumnEnum.State,
                'col-id-fixed-size' : column.id === taskViewColumnEnum.TaskId || column.id === taskViewColumnEnum.FolderId,
                'col-date-fixed-size' : column.id === taskViewColumnEnum.LimitDate,
                'col-date-time-fixed-size' : column.id === taskViewColumnEnum.CreationDate,
                'pointer': isSortableRow(column.id)
              }"
              class="th-sm">
              <fa-icon
                *ngIf="isSortableRow(column.id)"
                [fixedWidth]="true"
                [icon]="asc ? caretUp : caretDown"
                class="{{ sortBy === (column.id | columToFolderSortBy) ? 'visible' : 'invisible' }}">
              </fa-icon>
              {{ column.type === columnTypeEnum.Metadata ? column.metadata?.name : column.id | columnNamePipe }}
            </th>
          </ng-container>
        </tr>
      </thead>
      <tbody
        app-list-loader
        [data]="folders"
        [loading]="loading"
        [colspan]="colspan"
        [emptyMessage]="commonMessages.EMPTY_FOLDER_LIST">
      </tbody>
      <tbody>
        <tr
          *ngFor="let folder of folders"
          class="w-100">
          <td class="ps-0 text-end col-icon-fixed-size">
            <div class="custom-control custom-checkbox">
              <div>
                <input
                  (change)="setActionsToDisplay()"
                  [(ngModel)]="folder.selected"
                  [id]="'checkbox_' + folder.id"
                  class="custom-control-input"
                  type="checkbox">
                <label
                  [htmlFor]="'checkbox_' + folder.id"
                  class="custom-control-label">
                </label>
              </div>
            </div>
          </td>
          <ng-container *ngFor="let column of usedColumns">
            <td *ngIf="(shouldShowIdColumn() || !isIdColumn(column)) && (column.id !== 'ORIGIN_USER' || show52Features)">
              <div
                *ngIf="column.id === taskViewColumnEnum.State"
                [class]="{'sortable-row': show52Features}">
                <fa-icon
                  *ngIf="doesFolderHaveToBeRead(folder)"
                  [fixedWidth]="true"
                  [icon]="commonIcons.WARNING_ICON"
                  [ngbTooltip]="messages.READING_MANDATORY">
                </fa-icon>
                <fa-icon
                  *ngIf="!doesFolderHaveToBeRead(folder)"
                  [fixedWidth]="true"
                  [icon]="folder.readByCurrentUser ? eyeIcon : eyeSlashIcon"
                  [ngbTooltip]="folder.readByCurrentUser ? messages.READ : messages.UNREAD">
                </fa-icon>
                <fa-icon
                  [fixedWidth]="true"
                  [icon]="folder.stepList[0]?.action | actionIcon: (folderState === stateEnum.Downstream)"
                  [ngbTooltip]="folder.stepList[0]?.action | actionName: true: true: (folderState === stateEnum.Downstream): folder.stepList[0]?.externalState"
                  class="ps-2">
                </fa-icon>
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.FolderName"
                class="sortable-row overflow-hidden text-overflow-ellipsis"
                [ngbTooltip]="folder.name | namePipe">
                <a
                  [routerLink]="legacyDeskService.getFolderViewUrl(tenant.id, deskId, folder.id)"
                  [queryParams]="legacyDeskService.getAsDeskQueryParam(getTargetDeskId(folder))"
                  [innerText]="folder.name | namePipe">
                </a>
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.Type"
                [class]="{'sortable-row': show52Features}"
                [innerText]="folder.type?.name | namePipe">
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.Subtype"
                [class]="{'sortable-row': show52Features}"
                [innerText]="folder.subtype?.name | namePipe">
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.CreationDate"
                class="sortable-row"
                [innerText]="(show52Features ? folder.draftCreationDate : folder.stepList[0].beginDate) | date: 'short'">
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.LimitDate"
                class="sortable-row"
                [innerText]="folder.dueDate | date: 'shortDate'"
                [ngClass]="{ 'text-danger': isDateBeforeNow(folder.dueDate) }">
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.CurrentDesk"
                class="sortable-row overflow-hidden text-overflow-ellipsis"
                [ngbTooltip]="getCurrentDeskNameIfAppropriate(folder)"
                [innerText]="getCurrentDeskNameIfAppropriate(folder)">
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.OriginDesk"
                class="sortable-row overflow-hidden text-overflow-ellipsis"
                [ngbTooltip]="folder.originDesk?.name | namePipe"
                [innerText]="folder.originDesk?.name | namePipe">
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.OriginUser"
                class="sortable-row overflow-hidden text-overflow-ellipsis"
                [ngbTooltip]="prettyPrintUserFn(folder.originUser)"
                [innerText]="prettyPrintUserFn(folder.originUser)">
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.TaskId"
                class="sortable-row font-monospace text-size-small"
                [innerText]="folder.stepList[0].id">
              </div>
              <div
                *ngIf="column.id === taskViewColumnEnum.FolderId"
                class="sortable-row font-monospace text-size-small"
                [innerText]="folder.id">
              </div>
              <div
                *ngIf="column.type == columnTypeEnum.Metadata && show52Features"
                class="sortable-row">
                <app-metadata-span
                  *ngIf="column.metadata"
                  [metadata]="column.metadata"
                  [value]="folder.metadata[column?.metadata?.id]">
                </app-metadata-span>
              </div>
            </td>
          </ng-container>
        </tr>
      </tbody>
    </table>
    <ngb-pagination
      [(page)]="page"
      [boundaryLinks]="false"
      [collectionSize]="total"
      [directionLinks]="false"
      [maxSize]="5"
      [pageSize]="getPageSize(pageSizeIndex)"
      [rotate]="true"
      (pageChange)="pageChange($event)"
      class="d-flex justify-content-end"
      size="sm">
    </ngb-pagination>
  </div>
</div>
